
/*

100kz I2C test routine for HMC5843 on dsPIC33FJ256MC710
Internal FRC and EMUC2/EMUD2 are used see micro_frc.c for config and osc startup

Oscillator changes may require modification of I2C1BRG in function InitI2C
Standard connections to I2C 1 module at pins 56 and 57
Standard output on uart 1 at 38400 baud

Mitch

*/


#include <stdio.h>
#include <math.h>
#include "micro_frc.h"
#include "uart1.h"
#include "hmc5843.h"



int main ()
{	struct intvector mag;	// integer vector of magnetometer measurements
	#define magx mag.x.i16	// x axis
	#define magy mag.y.i16	// y axis
	#define magz mag.z.i16	// z axis

	microcontroller_init();

	uart1_open(38400);		// open UART1
	printf ("Starting test...\n\r");

	InitI2C();				// Initialise the I2C(1) module
	init_HMC5843();			// initialize the HMC5843 chip
	test_HMC5843();			// display configuration and ID registers

	while(1)
	{
		HMC5843(&mag);		// update magnetometer data

		printf( "%5d %5d %5d\r",magx,magy,magz);

		microcontroller_delay_ms(100);
		
	}	// end while
}		// end main


